Index: mythvideo/mythvideo.pro
===================================================================
RCS file: /var/lib/mythcvs/mythvideo/mythvideo/mythvideo.pro,v
retrieving revision 1.22
diff -u -r1.22 mythvideo.pro
--- mythvideo/mythvideo.pro	25 Jan 2005 23:03:41 -0000	1.22
+++ mythvideo/mythvideo.pro	18 Feb 2005 21:05:24 -0000
@@ -25,11 +25,11 @@
 
 HEADERS += metadata.h videomanager.h videobrowser.h videofilter.h dbcheck.h
 HEADERS += globalsettings.h videotree.h fileassoc.h editmetadata.h
-HEADERS += videogallery.h videoselected.h videodlg.h
+HEADERS += videogallery.h videoselected.h videodlg.h videolist.h
 
 SOURCES += main.cpp metadata.cpp videomanager.cpp videobrowser.cpp videofilter.cpp dbcheck.cpp
 SOURCES += globalsettings.cpp videotree.cpp fileassoc.cpp editmetadata.cpp
-SOURCES += videogallery.cpp videoselected.cpp videodlg.cpp
+SOURCES += videogallery.cpp videoselected.cpp videodlg.cpp videolist.cpp
 
 macx {
     QMAKE_LFLAGS += -flat_namespace -undefined suppress
Index: mythvideo/videobrowser.cpp
===================================================================
RCS file: /var/lib/mythcvs/mythvideo/mythvideo/videobrowser.cpp,v
retrieving revision 1.41
diff -u -r1.41 videobrowser.cpp
--- mythvideo/videobrowser.cpp	8 Feb 2005 08:26:57 -0000	1.41
+++ mythvideo/videobrowser.cpp	18 Feb 2005 21:05:24 -0000
@@ -162,6 +162,7 @@
     m_list.clear();
 
     VideoDialog::fetchVideos();
+    video_list->wantVideoListUpdirs(true);
     
     updateML = false;
     SetCurrentItem();
Index: mythvideo/videodlg.cpp
===================================================================
RCS file: /var/lib/mythcvs/mythvideo/mythvideo/videodlg.cpp,v
retrieving revision 1.7
diff -u -r1.7 videodlg.cpp
--- mythvideo/videodlg.cpp	9 Feb 2005 21:35:13 -0000	1.7
+++ mythvideo/videodlg.cpp	18 Feb 2005 21:05:25 -0000
@@ -40,12 +40,15 @@
     allowPaint = true;
     currentParentalLevel = gContext->GetNumSetting("VideoDefaultParentalLevel", 1);
     currentVideoFilter = new VideoFilterSettings(db, true, _winName);
+
+    video_list = new VideoList(_db);
+    video_tree_root = NULL;
 }
 
 VideoDialog::~VideoDialog()
 {
-    if (currentVideoFilter)
-        delete currentVideoFilter;
+    delete currentVideoFilter;
+    delete video_list;
     
 }
 
@@ -439,33 +442,25 @@
 }
 
 
+GenericTree *VideoDialog::getVideoTreeRoot(void)
+{
+    return(video_tree_root);
+}
+
 void VideoDialog::fetchVideos()
 {
+    typedef QMap<int, Metadata> metaMap;
     
-    QString thequery = QString("SELECT intid FROM %1 %2 %3")
-                        .arg(currentVideoFilter->BuildClauseFrom())
-                        .arg(currentVideoFilter->BuildClauseWhere())
-                        .arg(currentVideoFilter->BuildClauseOrderBy());
+    metaMap myMetas;
+    metaMap::Iterator it;
 
-    MSqlQuery query(thequery,db);
-    
-    Metadata *myData;
+    video_tree_root = video_list->buildVideoList(currentParentalLevel);
 
-    if (query.isActive() && query.size() > 0)
-    {
-        while (query.next())
-        {
-            myData = new Metadata();
-            
-            myData->setID(query.value(0).toUInt());
-            myData->fillDataFromID(db);
-            if (myData->ShowLevel() <= currentParentalLevel && myData->ShowLevel() != 0)
-            {
-                handleMetaFetch(myData);
-            }
-        
-            delete myData;
-        }
+    // XXX: This is suboptimal. The classes should not need this. They
+    //      can retrieve the data through VideoList::getVideoListMetadata()
+    myMetas = video_list->getVideoListMetas();
+    for (it = myMetas.begin(); it != myMetas.end(); ++it) {
+            handleMetaFetch(&it.data());
     }
 
 }
Index: mythvideo/videodlg.h
===================================================================
RCS file: /var/lib/mythcvs/mythvideo/mythvideo/videodlg.h,v
retrieving revision 1.3
diff -u -r1.3 videodlg.h
--- mythvideo/videodlg.h	22 Aug 2004 18:16:32 -0000	1.3
+++ mythvideo/videodlg.h	18 Feb 2005 21:05:25 -0000
@@ -10,6 +10,7 @@
 #include <mythtv/uitypes.h>
 
 #include "metadata.h"
+#include "videolist.h"
 
 class VideoFilterSettings;
 
@@ -31,6 +32,7 @@
         QString getHandler(Metadata *someItem);
         QString getCommand(Metadata *someItem);
         bool checkParentPassword();
+        GenericTree *getVideoTreeRoot(void);
         
     protected slots:
         void slotDoCancel();
@@ -71,6 +73,9 @@
         QDomElement xmldata;
         
         VideoFilterSettings *currentVideoFilter;
+
+        VideoList   *video_list;
+        GenericTree *video_tree_root;
 };
 
 #endif
Index: mythvideo/videogallery.cpp
===================================================================
RCS file: /var/lib/mythcvs/mythvideo/mythvideo/videogallery.cpp,v
retrieving revision 1.14
diff -u -r1.14 videogallery.cpp
--- mythvideo/videogallery.cpp	21 Nov 2004 14:58:32 -0000	1.14
+++ mythvideo/videogallery.cpp	18 Feb 2005 21:05:26 -0000
@@ -24,14 +24,10 @@
 #include "metadata.h"
 #include "videogallery.h"
 #include "videoselected.h"
+#include "videolist.h"
 #include <mythtv/mythcontext.h>
 #include <mythtv/util.h>
 
-const int SUB_FOLDER = -1;
-const int UP_FOLDER = -2;
-
-
-
 VideoGallery::VideoGallery(QSqlDatabase *ldb, MythMainWindow *parent, const char *name)
             : VideoDialog(DLG_GALLERY, ldb, parent, "gallery", name)
 {
@@ -44,22 +40,12 @@
     subtitleOn           = gContext->GetNumSetting("VideoGallerySubtitle",1);
     keepAspectRatio      = gContext->GetNumSetting("VideoGalleryAspectRatio",1);
 
+    // XXX Fixme: this is wrong...
     prefix = gContext->GetSetting("VideoStartupDir");
 
-    QString videodir = gContext->GetSetting("VideoStartupDir");
-    QStringList an_it(QStringList::split("/", videodir));
-
-
     loadWindow(xmldata);
     LoadIconWindow(); // load icon settings
 
-    if (!an_it.empty())
-        video_tree_root = new GenericTree(an_it.last() + "/", -3, false);
-    else
-        video_tree_root = new GenericTree(QString("/"), -3, false);
-
-    video_tree_data = video_tree_root;
-
     fetchVideos();
 
     setNoErase();
@@ -69,8 +55,6 @@
 {
     // save current settings as default
     gContext->SaveSetting("VideoDefaultView", curView);
-
-    delete video_tree_root;
 }
 
 
@@ -193,79 +177,18 @@
      return handled;
 }
 
-void VideoGallery::handleMetaFetch(Metadata* myData)
-{
-
-    metas[myData->ID()] = *myData;
-
-    if (curView == 0)  // create a flat linear list
-    {
-        video_tree_data->addNode(myData->Title(), myData->ID(), true);
-    }
-    else // create hierarchical tree based on the dir structure
-    {
-        QString file_string = myData->Filename();
-        file_string.remove(0, prefix.length());
-        QStringList list(QStringList::split("/", file_string));
-
-        //
-        // Analyze the complete path listing inside the filename.
-        // Each directory is a node and each video a leaf node.
-        //
-        GenericTree *where_to_add = video_tree_data;
-
-        int a_counter = 0;
-        QStringList::Iterator an_it = list.begin();
-        for( ; an_it != list.end(); ++an_it)
-        {
-            // Attributes are used to set the ordering
-            // The ordering is:
-            //   0 up-folder
-            //   1 subfolders
-            //   2 videos
-
-            GenericTree *sub_node;
-
-            if (a_counter + 1 >= (int) list.count())     // video
-            {
-                sub_node = where_to_add->addNode(myData->Title(), myData->ID(), true);
-                sub_node->setAttribute(0, 2);
-                sub_node->setOrderingIndex(0);
-            }
-            else
-            {
-                QString dirname = *an_it + "/";
-                sub_node = where_to_add->getChildByName(dirname);
-                if (!sub_node)                           // create subfolder
-                {
-                    // subfolder
-                    sub_node = where_to_add->addNode(dirname, SUB_FOLDER, true);
-                    sub_node->setAttribute(0, 1);
-                    sub_node->setOrderingIndex(0);
-
-                    // up-folder
-                    GenericTree *up_node = sub_node->addNode(where_to_add->getString(), UP_FOLDER, true);
-                    up_node->setAttribute(0, 0);
-                    up_node->setOrderingIndex(0);
-                }
-                where_to_add = sub_node;
-            }
-            ++a_counter;
-        }
-    }
-}
-
 void VideoGallery::fetchVideos()
 {
     if (updateML == true)
         return;
     updateML = true;
-    video_tree_data->deleteAllChildren();
-
+    
     VideoDialog::fetchVideos();
+    video_tree_root = VideoDialog::getVideoTreeRoot();
 
-    video_tree_data->setOrderingIndex(0);
-    video_tree_data->sortByAttributeThenByString(0);
+    video_list->wantVideoListUpdirs(true);
+    video_tree_root->setOrderingIndex(0);
+    video_tree_root->sortByAttributeThenByString(0);
 
     //
     // Select initial view
@@ -275,22 +198,24 @@
     topRow = currRow = currCol = 0; // icon in top-left corner
     lastRow = lastCol = 0;
 
-    where_we_are = video_tree_data; // root directory
-
+    where_we_are = video_tree_root; // root directory
+    
     int list_count = where_we_are->childCount();
-    if (list_count > 0)             // move already one node down if there are videos
+    if (list_count > 0) // move already one node down if there are videos
     {
-        where_we_are = video_tree_data->getChildAt(0,0);
+        where_we_are = video_tree_root->getChildAt(0,0);
         lastRow = QMAX((int)ceilf((float)list_count/(float)nCols)-1,0);
         lastCol = QMAX(list_count-lastRow*nCols-1,0);
     }
-
+    
     allowselect = (bool)(where_we_are != video_tree_root);
 
     updateML = false;
     update();         // renew the screen
-
-    curitem = &metas[where_we_are->getInt()];
+    
+    if (where_we_are->getInt() >= 0)
+        curitem = video_list->getVideoListMetadata(where_we_are->getInt());
+    else curitem = NULL;
 }
 
 void VideoGallery::paintEvent(QPaintEvent *e)
@@ -489,7 +414,7 @@
             p->drawPixmap(xpos, ypos, backRegPix);
 
         // load video icon
-        meta = &metas[curTreePos->getInt()];
+        meta = video_list->getVideoListMetadata(curTreePos->getInt());
 
         image = meta->getCoverImage();
         myImage = false;
@@ -783,7 +708,7 @@
         where_we_are = parent->getChildAt(currRow * nCols + currCol,0);
 
 
-    curitem = &metas[where_we_are->getInt()];
+    curitem = video_list->getVideoListMetadata(where_we_are->getInt());
 
 
     if (topRow != oldRow)     // renew the whole screen
@@ -873,7 +798,8 @@
 {
     cancelPopup();
 
-    VideoSelected *selected = new VideoSelected(db, gContext->GetMainWindow(),
+    VideoSelected *selected = new VideoSelected(db, video_list,
+                                                gContext->GetMainWindow(),
                                                 "video selected", where_we_are->getInt());
     qApp->unlock();
     selected->exec();
Index: mythvideo/videogallery.h
===================================================================
RCS file: /var/lib/mythcvs/mythvideo/mythvideo/videogallery.h,v
retrieving revision 1.7
diff -u -r1.7 videogallery.h
--- mythvideo/videogallery.h	13 Nov 2004 22:36:53 -0000	1.7
+++ mythvideo/videogallery.h	18 Feb 2005 21:05:26 -0000
@@ -50,7 +50,6 @@
     
   protected:
     virtual void parseContainer(QDomElement &element);
-    virtual void handleMetaFetch(Metadata*);
     virtual void fetchVideos();
     void doMenu(bool info=false);
     void paintEvent(QPaintEvent *);
@@ -77,10 +76,6 @@
 
     void positionIcon();
     
-    //typedef QValueVector<Metadata> MetaVector;
-    //MetaVector metas;
-    QMap<int, Metadata> metas;
-    
     int curView;
     bool subtitleOn;
     bool keepAspectRatio;
@@ -115,7 +110,6 @@
     QString prefix;
     
     GenericTree *video_tree_root;
-    GenericTree *video_tree_data;
     GenericTree *where_we_are;
 
     //typedef void (VideoGallery::*Action)(UIListBtnTypeItem*);
Index: mythvideo/videoselected.cpp
===================================================================
RCS file: /var/lib/mythcvs/mythvideo/mythvideo/videoselected.cpp,v
retrieving revision 1.9
diff -u -r1.9 videoselected.cpp
--- mythvideo/videoselected.cpp	9 Feb 2005 21:35:13 -0000	1.9
+++ mythvideo/videoselected.cpp	18 Feb 2005 21:05:26 -0000
@@ -32,18 +32,15 @@
 #include <mythtv/util.h>
 #include <mythtv/mythdbcon.h>
 
-
-VideoSelected::VideoSelected(QSqlDatabase *ldb,
+VideoSelected::VideoSelected(QSqlDatabase *ldb, VideoList *lvideo_list,
                              MythMainWindow *parent, const char *name, 
                              int idnum)
             : MythDialog(parent, name)
 {
     db = ldb;
+    video_list = lvideo_list;
 
-    curitem = new Metadata();
-    curitem->setID(idnum);
-    curitem->fillDataFromID(db);
-
+    curitem = video_list->getVideoListMetadata(idnum);
     noUpdate = false;
     m_state = 0;
 
@@ -69,8 +66,6 @@
 {
     delete theme;
     delete bgTransBackup;
-    if (curitem)
-        delete curitem;
 }
 
 void VideoSelected::keyPressEvent(QKeyEvent *e)
@@ -187,13 +182,12 @@
     // Play the movie
     myth_system((QString("%1 ") .arg(m_cmd)).local8Bit());
 
-    Metadata *childItem = new Metadata;
-    Metadata *parentItem = new Metadata(*curitem);
+    Metadata *childItem;
+    Metadata *parentItem = curitem;
 
     while (parentItem->ChildID() > 0 && playing_time.elapsed() > 10000)
     {
-        childItem->setID(parentItem->ChildID());
-        childItem->fillDataFromID(db);
+        childItem = video_list->getVideoListMetadata(parentItem->ChildID());
 
         if (parentItem->ChildID() > 0)
         {
@@ -203,13 +197,9 @@
             myth_system((QString("%1 ") .arg(m_cmd)).local8Bit());
         }
 
-        delete parentItem;
-        parentItem = new Metadata(*childItem);
+        parentItem = childItem;
     }
 
-    delete childItem;
-    delete parentItem;
-
     backup.begin(this);
     backup.drawPixmap(0, 0, myBackground);
     backup.end();
Index: mythvideo/videoselected.h
===================================================================
RCS file: /var/lib/mythcvs/mythvideo/mythvideo/videoselected.h,v
retrieving revision 1.3
diff -u -r1.3 videoselected.h
--- mythvideo/videoselected.h	14 Oct 2004 04:20:28 -0000	1.3
+++ mythvideo/videoselected.h	18 Feb 2005 21:05:26 -0000
@@ -20,6 +20,7 @@
 #include <qstringlist.h>
 
 #include "metadata.h"
+#include "videolist.h"
 #include <mythtv/mythwidgets.h>
 #include <qdom.h>
 #include <mythtv/uitypes.h>
@@ -32,7 +33,7 @@
 {
     Q_OBJECT
   public:
-    VideoSelected(QSqlDatabase *ldb, 
+    VideoSelected(QSqlDatabase *ldb, VideoList *lvideolist,
                  MythMainWindow *parent, const char *name = 0, int idnum = 0);
     ~VideoSelected();
     void VideoSelected::processEvents() { qApp->processEvents(); }
@@ -77,6 +78,8 @@
     QRect fullRect;
 
     bool allowselect;
+
+    VideoList *video_list;
 };
 
 #endif
Index: mythvideo/videotree.cpp
===================================================================
RCS file: /var/lib/mythcvs/mythvideo/mythvideo/videotree.cpp,v
retrieving revision 1.37
diff -u -r1.37 videotree.cpp
--- mythvideo/videotree.cpp	9 Feb 2005 21:35:13 -0000	1.37
+++ mythvideo/videotree.cpp	18 Feb 2005 21:05:27 -0000
@@ -17,6 +17,7 @@
 #include <mythtv/mythdbcon.h>
 
 #include "videofilter.h"
+#include "videolist.h"
 const long WATCHED_WATERMARK = 10000; // Less than this and the chain of videos will 
                                       // not be followed when playing.
 
@@ -34,15 +35,14 @@
     current_parental_level = gContext->GetNumSetting("VideoDefaultParentalLevel", 1);
 
     file_browser = gContext->GetNumSetting("VideoTreeNoDB", 0);
-    browser_mode_files.clear();
-        
+
     //
     //  Theme and tree stuff
     //
 
     wireUpTheme();
-    video_tree_root = new GenericTree("video root", -2, false);
-    
+    video_list = new VideoList(ldb);
+    video_tree_root = NULL;
     currentVideoFilter = new VideoFilterSettings(db, true, "VideoTree");
     
     buildVideoList();
@@ -59,6 +59,7 @@
     }
 
     updateForeground();
+    video_tree_list->enter();
 }
 
 VideoTree::~VideoTree()
@@ -66,9 +67,6 @@
     if (currentVideoFilter)
         delete currentVideoFilter;
 
-    if (curitem)
-        delete curitem;
-        
     delete video_tree_root;
 }
 
@@ -232,269 +230,23 @@
             video_tree_list->setCurrentNode(video_tree_data->getChildAt(0, 0));
         }
         updateForeground();
-    }
-}
-
-bool VideoTree::ignoreExtension(QString extension)
-{
-    MSqlQuery query(QString::null, db);
-    query.prepare("SELECT f_ignore FROM videotypes WHERE extension = :EXT ;");
-    query.bindValue(":EXT", extension);
-    if(query.exec() && query.isActive() && query.size() > 0)
-    {
-        query.next();
-        return query.value(0).toBool();
-    }
-    
-    return !gContext->GetNumSetting("VideoListUnknownFileTypes", 1);
-
-}
-
-void VideoTree::buildFileList(QString directory)
-{
-    QDir d(directory);
-
-    d.setSorting(QDir::DirsFirst | QDir::Name | QDir::IgnoreCase);
-
-    if (!d.exists())
-        return;
-
-    const QFileInfoList *list = d.entryInfoList();
-    if (!list)
-        return;
-
-    QFileInfoListIterator it(*list);
-    QFileInfo *fi;
-    QRegExp r;
-
-    while ((fi = it.current()) != 0)
-    {
-        ++it;
-        if (fi->fileName() == "." || 
-            fi->fileName() == ".." ||
-            fi->fileName() == "Thumbs.db")
-        {
-            continue;
-        }
-        
-        if(!fi->isDir())
-        {
-            if(ignoreExtension(fi->extension(false)))
-            {
-                continue;
-            }
-        }
-        
-        QString filename = fi->absFilePath();
-        if (fi->isDir())
-            buildFileList(filename);
-        else
-        {
-            browser_mode_files.append(filename);
-        }
+        video_tree_list->enter();
     }
 }
 
 void VideoTree::buildVideoList()
 {
-    if(file_browser)
-    {
-        //
-        //  Fill metadata from directory structure
-        //
-        
-        QStringList nodesname;
-        QStringList nodespath;
-
-        nodespath.append(gContext->GetSetting("VideoStartupDir"));
-        nodesname.append("videos");
-
-
-        //
-        // See if there are removable media available, so we can add them
-        // to the tree.
-        //
-        MediaMonitor * mon = MediaMonitor::getMediaMonitor();
-        if (mon)
-        {
-            QValueList <MythMediaDevice*> medias =
-                                        mon->getMedias(MEDIATYPE_DATA);
-            QValueList <MythMediaDevice*>::Iterator itr = medias.begin();
-            MythMediaDevice *pDev;
-
-            while(itr != medias.end())
-            {
-                pDev = *itr;
-                if (pDev)
-                {
-                    QString path = pDev->getMountPath();
-                    QString name = path.right(path.length()
-                                                - path.findRev("/")-1);
-                    nodespath.append(path);
-                    nodesname.append(name);
-                }
-                itr++;
-            }
-        }
-
-        for (uint j=0; j < nodesname.count(); j++)
-        {
-            video_tree_data = video_tree_root->addNode(nodesname[j], -2, false);
-            buildFileList(nodespath[j]);
-        }
-
-        unsigned int mainnodeindex = 0;
-        QString prefix = nodespath[mainnodeindex];
-        GenericTree *where_to_add = video_tree_root->getChildAt(mainnodeindex);
-
-        for(uint i=0; i < browser_mode_files.count(); i++)
-        {
-            
-            QString file_string = *(browser_mode_files.at(i));
-            if (prefix.compare(file_string.left(prefix.length())) != 0)
-            {
-                if (mainnodeindex++ < nodespath.count()) {
-                    prefix = nodespath[mainnodeindex];
-                }
-                else {
-                    cerr << "videotree.o: mainnodeindex out of bounds" << endl;
-                    break;
-                }
-            }
-            where_to_add = video_tree_root->getChildAt(mainnodeindex);
-            if(prefix.length() < 1)
-            {
-                cerr << "videotree.o: weird prefix.lenght" << endl;
-                break;
-            }
-
-            file_string.remove(0, prefix.length());
-            QStringList list(QStringList::split("/", file_string));
-
-            int a_counter = 0;
-            QStringList::Iterator an_it = list.begin();
-            for( ; an_it != list.end(); ++an_it)
-            {
-                if(a_counter + 1 >= (int) list.count())
-                {
-                    QString title = (*an_it);
-                    where_to_add->addNode(title.section(".",0,-2), i, true);
-                }
-                else
-                {
-                    QString dirname = *an_it + "/";
-                    GenericTree *sub_node;
-                    sub_node = where_to_add->getChildByName(dirname);
-                    if(!sub_node)
-                    {
-                        sub_node = where_to_add->addNode(dirname, -1, false);
-                    }
-                    where_to_add = sub_node;
-                }
-                ++a_counter;
-            }
-        }
-        if(video_tree_data->childCount() < 1)
-        {
-            //
-            //  Nothing survived the requirements
-            //
-
-            video_tree_data->addNode(tr("No files found"), -1, false);
-        }        
-    }
-    else
-    {
-        //
-        //  This just asks the database for a list
-        //  of metadata, builds it into a tree and
-        //  passes that tree structure to the GUI
-        //  widget that handles navigation
-        //
-
-        QString thequery = QString("SELECT intid FROM %1 %2 %3")
-                    .arg(currentVideoFilter->BuildClauseFrom())
-                    .arg(currentVideoFilter->BuildClauseWhere())
-                    .arg(currentVideoFilter->BuildClauseOrderBy());
-        
-        MSqlQuery query(thequery,db);
-        Metadata *myData;
-        if (!video_tree_data)
-            video_tree_data = video_tree_root->addNode("videos", -2, false);
-        
-        if(!query.isActive())
-        {
-            cerr << "videotree.o: Your database sucks" << endl;
-        }
-        else if (query.size() > 0)
-        {
-            QString prefix = gContext->GetSetting("VideoStartupDir");
-            if(prefix.length() < 1)
-            {
-                  cerr << "videotree.o: Seems unlikely that this is going to work" << endl;
-            }
-            while (query.next())
-            {
-                unsigned int idnum = query.value(0).toUInt();
-
-                //
-                //  Create metadata object and fill it
-                //
-            
-                myData = new Metadata();
-                myData->setID(idnum);
-                myData->fillDataFromID(db);
-                if (myData->ShowLevel() <= current_parental_level && myData->ShowLevel() != 0)
-                {
-                    QString file_string = myData->Filename();
-
-                    file_string.remove(0, prefix.length());
-                    QStringList list(QStringList::split("/", file_string));
-
-                    GenericTree *where_to_add;
-                    where_to_add = video_tree_data;
-                    int a_counter = 0;
-                    QStringList::Iterator an_it = list.begin();
-                    for( ; an_it != list.end(); ++an_it)
-                    {
-                        if(a_counter + 1 >= (int) list.count())
-                        {
-                            where_to_add->addNode(myData->Title(), idnum, true);                    
-                        }
-                        else
-                        {
-                            QString dirname = *an_it + "/";
-                            GenericTree *sub_node;
-                            sub_node = where_to_add->getChildByName(dirname);
-                            if(!sub_node)
-                            {
-                                sub_node = where_to_add->addNode(dirname, -1, false);
-                            }
-                            where_to_add = sub_node;
-                        }
-                        ++a_counter;
-                    }
-                }
-            
-                //
-                //  Kill it off
-                //
-            
-                delete myData;
-            }
-        }
-        else
-        {
-            video_tree_data->addNode(tr("No files found"), -2, false);
-        }
-    }
+    video_tree_root = video_list->buildVideoList(current_parental_level);
+    if (video_tree_root->childCount() > 0)
+        video_tree_data = video_tree_root->getChildAt(0,0);
+    else video_tree_data = video_tree_root;
+    video_list->wantVideoListUpdirs(false);
     
     video_tree_list->assignTreeData(video_tree_root);
     video_tree_list->sortTreeByString();
     video_tree_list->sortTreeBySelectable();
 }
 
-
 void VideoTree::handleTreeListEntry(int node_int, IntVector*)
 {
     if(node_int > -1)
@@ -507,78 +259,27 @@
         QString player = "";
         QString unique_player;
             
-        if(file_browser)
+        curitem = video_list->getVideoListMetadata(node_int);
+        if (curitem == NULL)
+            return;
+
+        video_title->SetText(curitem->Title());
+        video_file->SetText(curitem->Filename().section("/", -1));
+        video_poster->SetImage(curitem->CoverFile());
+        video_poster->LoadImage();
+        if (video_plot)
+                video_plot->SetText(curitem->Plot());
+
+        extension = curitem->Filename().section(".", -1, -1);
+
+        unique_player = curitem->PlayCommand();
+        if(unique_player.length() > 0)
         {
-            if(node_int >= (int) browser_mode_files.count())
-            {
-                cerr << "videotree.o: Uh Oh. Reference larger than count of browser_mode_files" << endl;
-                
-            }
-            else
-            {
-                if (!curitem)
-                    curitem = new Metadata();
-                else
-                    curitem->reset();
-                    
-                QString the_file = *(browser_mode_files.at(node_int));
-                QString base_name = the_file.section("/", -1);
-
-                /* See if we can find this filename in DB */
-                curitem->setFilename(the_file);
-                
-                if(curitem->fillDataFromFilename(db)) 
-                {
-                    video_title->SetText(curitem->Title());
-                    video_file->SetText(curitem->Filename().section("/", -1));
-                    video_poster->SetImage(curitem->CoverFile());
-                    video_poster->LoadImage();
-                    if (video_plot)
-                        video_plot->SetText(curitem->Plot());
-                }
-                else
-                {
-                    /* Nope, let's make the best of the situation */
-                    video_title->SetText(base_name.section(".", 0, -2));
-                    video_file->SetText(base_name);
-                    video_poster->ResetImage();
-                    curitem->setTitle(base_name.section(".", 0, -2));
-                    curitem->setPlayer(player);
-                    if (video_plot)
-                        video_plot->SetText(" ");
-                }
-                
-                extension = the_file.section(".", -1);
-                player = gContext->GetSetting("VideoDefaultPlayer");
-                
-            }
+            player = unique_player;
         }
         else
         {
-            if (!curitem)
-                curitem = new Metadata();
-                            
-            curitem->setID(node_int);
-            curitem->fillDataFromID(db);
-            video_title->SetText(curitem->Title());
-            video_file->SetText(curitem->Filename().section("/", -1));
-            video_poster->SetImage(curitem->CoverFile());
-            video_poster->LoadImage();
-            extension = curitem->Filename().section(".", -1, -1);
-            if (video_plot)
-                    video_plot->SetText(curitem->Plot());
-                    
-            unique_player = curitem->PlayCommand();
-            
-            if(unique_player.length() > 0)
-            {
-                player = unique_player;
-            }
-            else
-            {
-                player = gContext->GetSetting("VideoDefaultPlayer");
-            }
-
+            player = gContext->GetSetting("VideoDefaultPlayer");
         }
 
         //
@@ -604,7 +305,6 @@
             }
         }
 
-        
         video_player->SetText(player); 
     }
     else
@@ -619,7 +319,6 @@
         video_player->SetText(""); 
         
     }
-    
 }
 
 void VideoTree::playVideo(int node_number)
@@ -630,7 +329,6 @@
     }
 }
 
-
 void VideoTree::handleTreeListSelection(int node_int, IntVector *)
 {
     if(node_int > -1)
Index: mythvideo/videotree.h
===================================================================
RCS file: /var/lib/mythcvs/mythvideo/mythvideo/videotree.h,v
retrieving revision 1.10
diff -u -r1.10 videotree.h
--- mythvideo/videotree.h	22 Aug 2004 18:16:32 -0000	1.10
+++ mythvideo/videotree.h	18 Feb 2005 21:05:27 -0000
@@ -9,6 +9,7 @@
 #include <mythtv/uitypes.h>
 
 #include "metadata.h"
+#include "videolist.h"
 
 class QSqlDatabase;
 class VideoFilterSettings;
@@ -27,8 +28,6 @@
    ~VideoTree();
 
     void buildVideoList();
-    void buildFileList(QString directory);
-    bool ignoreExtension(QString extension);
     
     virtual void playVideo(Metadata *someItem);
     QString getHandler(Metadata *someItem);
@@ -63,8 +62,7 @@
     int          current_parental_level;
     QSqlDatabase *db;
     bool         file_browser;
-    QStringList  browser_mode_files;
-       
+
     //
     //  Theme-related "widgets"
     //
@@ -72,6 +70,7 @@
     UIManagedTreeListType *video_tree_list;
     GenericTree           *video_tree_root;
     GenericTree           *video_tree_data;
+    VideoList             *video_list;
     UITextType            *video_title;
     UITextType            *video_file;
     UITextType            *video_plot;
